create or replace PROCEDURE CALCULA_TAR
   (P_CDEMPRESA   IN TMPCONTABGER.CDEMPRESATMP%TYPE,
    P_CDTIPODEMO  IN TMPCONTABGER.CDTIPODEMOTMP%TYPE,
    P_DTINICIAL   IN DATE,
    P_DTFINAL     IN DATE) AS

   V_DTINICIAL    DATE;
   V_NRLISTA      VARCHAR2(20);
   V_NRCONTABGER  VARCHAR2(20);
   V_VRCONTDATA   NUMBER;
   V_COUNT        NUMBER;

   V_VRFATLIQU01  NUMBER;
   V_VRFATLIQU02  NUMBER;
   V_VRFATLIQU03  NUMBER;
   V_VRFATLIQU04  NUMBER;
   V_VRFATLIQU05  NUMBER;
   V_VRFATLIQU06  NUMBER;
   V_VRFATLIQU07  NUMBER;
   V_VRFATLIQU08  NUMBER;
   V_VRFATLIQU09  NUMBER;
   V_VRFATLIQU10  NUMBER;
   V_VRFATLIQU11  NUMBER;
   V_VRFATLIQU12  NUMBER;

   V_VRCUSREGE01  NUMBER;
   V_VRCUSREGE02  NUMBER;
   V_VRCUSREGE03  NUMBER;
   V_VRCUSREGE04  NUMBER;
   V_VRCUSREGE05  NUMBER;
   V_VRCUSREGE06  NUMBER;
   V_VRCUSREGE07  NUMBER;
   V_VRCUSREGE08  NUMBER;
   V_VRCUSREGE09  NUMBER;
   V_VRCUSREGE10  NUMBER;
   V_VRCUSREGE11  NUMBER;
   V_VRCUSREGE12  NUMBER;

   V_DTREFETMP01  DATE;
   V_DTREFETMP02  DATE;
   V_DTREFETMP03  DATE;
   V_DTREFETMP04  DATE;
   V_DTREFETMP05  DATE;
   V_DTREFETMP06  DATE;
   V_DTREFETMP07  DATE;
   V_DTREFETMP08  DATE;
   V_DTREFETMP09  DATE;
   V_DTREFETMP10  DATE;
   V_DTREFETMP11  DATE;
   V_DTREFETMP12  DATE;

   V_VRFATLIQU    NUMBER;
   V_VRCUSREGE    NUMBER;
   V_DTTARREGE    DATE;
   V_VRTAXATMP NUMBER;
   V_MESESANT NUMBER;

BEGIN
   V_VRCONTDATA := 0;
   NOVO_CODIGO('LISTA', V_NRLISTA);
   V_NRLISTA := SUBSTR(V_NRLISTA, 11, 10);
   
   V_DTINICIAL := P_DTINICIAL;

   INSERT INTO LISTA
      (NRLISTA, CDLISTA)
      (SELECT V_NRLISTA, CDFILIAL
       FROM FILIAL
       WHERE CDAREAGERE IS NOT NULL);

   /*  necessio rodar o DRE gerencial para ter os valores de clculo da TAR.
      A TAC no usa o DRE como base, pois  a fixa de 6 */
   GERA_DREGERENCIAL(P_CDEMPRESA, V_NRLISTA, P_CDTIPODEMO, V_DTINICIAL, LAST_DAY(V_DTINICIAL), NULL, 0, V_NRCONTABGER);

   FOR C IN (
      SELECT CDAREAGERE
        FROM AREAGERE
       ORDER BY CDAREAGERE
   ) LOOP

      /* Select para pegar o valor de todo o faturamento da regional, com exceo
         da filial onde o supervisor  o operador TAR, pois ele ser usado como base
         de clculo. Na Sapore o cdigo 0030 trata o faturamento */
      SELECT SUM(VRREFETMP01)  VRREFETMP01, SUM(VRREFETMP02)  VRREFETMP02,
             SUM(VRREFETMP03)  VRREFETMP03, SUM(VRREFETMP04)  VRREFETMP04,
             SUM(VRREFETMP05)  VRREFETMP05, SUM(VRREFETMP06)  VRREFETMP06,
             SUM(VRREFETMP07)  VRREFETMP07, SUM(VRREFETMP08)  VRREFETMP08,
             SUM(VRREFETMP09)  VRREFETMP09, SUM(VRREFETMP10)  VRREFETMP10,
             SUM(VRREFETMP11)  VRREFETMP11, SUM(VRREFETMP12)  VRREFETMP12,
             MAX(DTREFETMP01)  DTREFETMP01, MAX(DTREFETMP02)  DTREFETMP02,
             MAX(DTREFETMP03)  DTREFETMP03, MAX(DTREFETMP04)  DTREFETMP04,
             MAX(DTREFETMP05)  DTREFETMP05, MAX(DTREFETMP06)  DTREFETMP06,
             MAX(DTREFETMP07)  DTREFETMP07, MAX(DTREFETMP08)  DTREFETMP08,
             MAX(DTREFETMP09)  DTREFETMP09, MAX(DTREFETMP10)  DTREFETMP10,
             MAX(DTREFETMP11)  DTREFETMP11, MAX(DTREFETMP12)  DTREFETMP12
        INTO V_VRFATLIQU01, V_VRFATLIQU02,
             V_VRFATLIQU03, V_VRFATLIQU04,
             V_VRFATLIQU05, V_VRFATLIQU06,
             V_VRFATLIQU07, V_VRFATLIQU08,
             V_VRFATLIQU09, V_VRFATLIQU10,
             V_VRFATLIQU11, V_VRFATLIQU12,
             V_DTREFETMP01, V_DTREFETMP02,
             V_DTREFETMP03, V_DTREFETMP04,
             V_DTREFETMP05, V_DTREFETMP06,
             V_DTREFETMP07, V_DTREFETMP08,
             V_DTREFETMP09, V_DTREFETMP10,
             V_DTREFETMP11, V_DTREFETMP12
        FROM TMPCONTABGER T, FILIAL F LEFT JOIN OPERADOR O
                                             ON F.CDSUPERVISOR = O.CDOPERADOR(+)
                                            AND NVL(O.NMOPERADOR,'NULL') <> 'TAR'
       WHERE T.CDEMPRESATMP = P_CDEMPRESA
         AND T.NRCONTABGER = V_NRCONTABGER
         AND T.CDFILIALTMP = F.CDFILIAL
         AND F.CDAREAGERE = C.CDAREAGERE
         AND T.CDITEMSTRUTMP = '0030';

      /* Soma todas as despesas e custos da filial que tem o supervisor TAR,
         desde que a regional seja a regional que est sendo processada */
      SELECT SUM(VRREFETMP01)  VRREFETMP01, SUM(VRREFETMP02)  VRREFETMP02,
             SUM(VRREFETMP03)  VRREFETMP03, SUM(VRREFETMP04)  VRREFETMP04,
             SUM(VRREFETMP05)  VRREFETMP05, SUM(VRREFETMP06)  VRREFETMP06,
             SUM(VRREFETMP07)  VRREFETMP07, SUM(VRREFETMP08)  VRREFETMP08,
             SUM(VRREFETMP09)  VRREFETMP09, SUM(VRREFETMP10)  VRREFETMP10,
             SUM(VRREFETMP11)  VRREFETMP11, SUM(VRREFETMP12)  VRREFETMP12
        INTO V_VRCUSREGE01, V_VRCUSREGE02,
             V_VRCUSREGE03, V_VRCUSREGE04,
             V_VRCUSREGE05, V_VRCUSREGE06,
             V_VRCUSREGE07, V_VRCUSREGE08,
             V_VRCUSREGE09, V_VRCUSREGE10,
             V_VRCUSREGE11, V_VRCUSREGE12
        FROM TMPCONTABGER T, FILIAL F, OPERADOR O
       WHERE T.CDEMPRESATMP = P_CDEMPRESA
         AND T.NRCONTABGER = V_NRCONTABGER
         AND T.CDFILIALTMP = F.CDFILIAL
         AND F.CDAREAGERE = C.CDAREAGERE
         AND F.CDSUPERVISOR = O.CDOPERADOR
         AND O.NMOPERADOR = 'TAR'
         AND T.CDITEMSTRUTMP IN ('0040','0050','0060', '0062');

      V_VRCONTDATA := 1;

      WHILE (V_VRCONTDATA <= 12) LOOP
         IF V_VRCONTDATA = 1 THEN
            V_DTTARREGE := V_DTREFETMP01;
            V_VRFATLIQU := V_VRFATLIQU01;
            V_VRCUSREGE := V_VRCUSREGE01;
         ELSIF V_VRCONTDATA = 2 THEN
            V_DTTARREGE := V_DTREFETMP02;
            V_VRFATLIQU := V_VRFATLIQU02;
            V_VRCUSREGE := V_VRCUSREGE02;
         ELSIF V_VRCONTDATA = 3 THEN
            V_DTTARREGE := V_DTREFETMP03;
            V_VRFATLIQU := V_VRFATLIQU03;
            V_VRCUSREGE := V_VRCUSREGE03;
         ELSIF V_VRCONTDATA = 4 THEN
            V_DTTARREGE := V_DTREFETMP04;
            V_VRFATLIQU := V_VRFATLIQU04;
            V_VRCUSREGE := V_VRCUSREGE04;
         ELSIF V_VRCONTDATA = 5 THEN
            V_DTTARREGE := V_DTREFETMP05;
            V_VRFATLIQU := V_VRFATLIQU05;
            V_VRCUSREGE := V_VRCUSREGE05;
         ELSIF V_VRCONTDATA = 6 THEN
            V_DTTARREGE := V_DTREFETMP06;
            V_VRFATLIQU := V_VRFATLIQU06;
            V_VRCUSREGE := V_VRCUSREGE06;
         ELSIF V_VRCONTDATA = 7 THEN
            V_DTTARREGE := V_DTREFETMP07;
            V_VRFATLIQU := V_VRFATLIQU07;
            V_VRCUSREGE := V_VRCUSREGE07;
         ELSIF V_VRCONTDATA = 8 THEN
            V_DTTARREGE := V_DTREFETMP08;
            V_VRFATLIQU := V_VRFATLIQU08;
            V_VRCUSREGE := V_VRCUSREGE08;
         ELSIF V_VRCONTDATA = 9 THEN
            V_DTTARREGE := V_DTREFETMP09;
            V_VRFATLIQU := V_VRFATLIQU09;
            V_VRCUSREGE := V_VRCUSREGE09;
         ELSIF V_VRCONTDATA = 10 THEN
            V_DTTARREGE := V_DTREFETMP10;
            V_VRFATLIQU := V_VRFATLIQU10;
            V_VRCUSREGE := V_VRCUSREGE10;
         ELSIF V_VRCONTDATA = 11 THEN
            V_DTTARREGE := V_DTREFETMP11;
            V_VRFATLIQU := V_VRFATLIQU11;
            V_VRCUSREGE := V_VRCUSREGE11;
         ELSIF V_VRCONTDATA = 12 THEN
            V_DTTARREGE := V_DTREFETMP12;
            V_VRFATLIQU := V_VRFATLIQU12;
            V_VRCUSREGE := V_VRCUSREGE12;
         END IF;

         /* Se o valor total de faturamento das filials  diferente de 0
            e o somatrio das despesas da filial com supervisor TAR  diferete de 0 */
         IF (NVL(V_VRFATLIQU,0) <> 0) AND (NVL(V_VRCUSREGE,0) <> 0) THEN
            IF V_DTTARREGE >= V_DTINICIAL THEN
               SELECT COUNT(*)
                 INTO V_COUNT
                 FROM TXDESPREGE
                WHERE CDAREAGERE = C.CDAREAGERE
                  AND DTTXDESPREGE = V_DTTARREGE;
                /* Clcula a TAR de acordo com as despesas da filial com supervisor TAR
                   dividas pelo faturamento da filial. Faz em forma de porcentagem. */
                IF V_COUNT <> 0 THEN
                   UPDATE TXDESPREGE
                      SET VRTXDESPREGE = ABS((V_VRCUSREGE/V_VRFATLIQU)*100),
                          VRFATLIQREGE = ABS(V_VRFATLIQU),
                          VRCUSTOREGE = ABS(V_VRCUSREGE)
                    WHERE CDAREAGERE = C.CDAREAGERE
                      AND DTTXDESPREGE = V_DTTARREGE;
                ELSE
                   INSERT INTO TXDESPREGE
                      (CDAREAGERE, DTTXDESPREGE, VRTXDESPREGE, VRFATLIQREGE, VRCUSTOREGE)
                   VALUES
                      (C.CDAREAGERE, V_DTTARREGE, ABS((V_VRCUSREGE/V_VRFATLIQU)*100), ABS(V_VRFATLIQU), ABS(V_VRCUSREGE));
                END IF;
            END IF;
         END IF;
         V_VRCONTDATA := V_VRCONTDATA + 1;
      END LOOP;
   END LOOP;

   /* Replica a TAC (valor fixo 6) para os prximos meses. Caso no enconte no ms anterior a rotina
      buscar at um ano para trs para fazer a replicao. */
   FOR C IN (
      SELECT DISTINCT CDAREAGERE
        FROM FILIAL F, OPERADOR O
       WHERE F.CDSUPERVISOR = O.CDOPERADOR
         AND O.NMOPERADOR = 'TAC') LOOP

     SELECT COUNT(*)
       INTO V_COUNT
       FROM TXDESPREGE
      WHERE CDAREAGERE = C.CDAREAGERE
        AND DTTXDESPREGE = V_DTINICIAL
        AND VRTXDESPREGE <> 0;
      /* Verifica se j existe TAC inserida para o ms que est rodando. */
      IF V_COUNT = 0 THEN
         V_MESESANT := 0;
         V_VRTAXATMP := 0;
         WHILE V_VRTAXATMP = 0 LOOP
            V_MESESANT := V_MESESANT - 1;
            BEGIN
               SELECT NVL(VRTXDESPREGE, 0)
                 INTO V_VRTAXATMP
                 FROM TXDESPREGE
                WHERE CDAREAGERE = C.CDAREAGERE
                  AND TRUNC(DTTXDESPREGE) = ADD_MONTHS(TRUNC(V_DTINICIAL), V_MESESANT);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRTAXATMP := 0;
            END;
            IF ABS(V_MESESANT) = 12 THEN  /* BUSCA AT 12 MESES PARA TRS BUSCANDO UMA TAXA VLIDA */
               V_VRTAXATMP := -1;
            END IF;
         END LOOP;
         IF V_VRTAXATMP = -1 THEN /* SE EST COMO -1  PORQUE NO ACHOU NENHUMA TAXA NO PERODO DE UM ANO PARA TRS DA DATA INICIAL */
            V_VRTAXATMP := 0;
         END IF;
         INSERT INTO TXDESPREGE
            (CDAREAGERE, DTTXDESPREGE, VRTXDESPREGE)
         VALUES
            (C.CDAREAGERE, V_DTINICIAL, V_VRTAXATMP);
      END IF;
   END LOOP;

   DELETE
     FROM TMPCONTABGER
    WHERE NRCONTABGER = V_NRCONTABGER;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_TAR','5.87.XXX'); END;
/