/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODUTOROP                                               */
/* Tabela : PRODUTOROP                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 29/05/2007 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRODUTOROP'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PRODUTOROP
GO


CREATE TRIGGER DTULTATU_PRODUTOROP
ON PRODUTOROP
FOR INSERT, UPDATE, DELETE
AS

BEGIN

   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODUTOROP', null, 'CDFILIAL=' + CDFILIAL + ';CDPRODUTO=' + CDPRODUTO +
                       ';IDTPPRODUTOROP=' + IDTPPRODUTOROP + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODUTOROP
      SET DTULTATUPRRP = GETDATE()
      FROM INSERTED;
   END;
   
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PRODUTOROP','4.11.136';
GO

