function LabelController($scope, templateManager, ScreenService, MessageService, ZHPromise, restEngine) {
    /* global Constants */
    let self = this;
    
    $scope.deleteLabel = function(currentRow) {
        MessageService.confirmMessageByCode("deleteLabel").then(() => {    
            let promise = self.pushPromiseDeleteLabel(currentRow.NRETIQUETA);
            
            ZHPromise.all(promise).then(function(callbacks) {
                const checkDelete = self.removeLabelFromList(currentRow.NRETIQUETA);
                const widgetAutoForn = templateManager.container.getWidget('autoForne');
                
                if (checkDelete) {
                    MessageService.notificationMessageByCode("successOnDeleteLabel", null, Constants.successNotification);
                    widgetAutoForn.reload();
                    self.checkLabelOnFilter(widgetAutoForn, currentRow.NRETIQUETA);
                }
            });
        });
    };
    
    this.checkLabelOnFilter = function(widgetAutoForn, nrEtiqueta) {
        const arrayLabelsOnFilter = widgetAutoForn.appliedFilter.FILTER_ROW.NRETIQUETA;
      
        if (arrayLabelsOnFilter && arrayLabelsOnFilter.length > 0) {
            const index = arrayLabelsOnFilter.indexOf(nrEtiqueta);
            
            if (index > -1) {
                widgetAutoForn.appliedFilter.FILTER_ROW.NRETIQUETA.splice(index, 1);
            }
        }
    };
    
    this.pushPromiseDeleteLabel = function(nrEtiqueta) {
        return restEngine.post('product#/deleteLabel', {
			"requestType": "Row",
			"row": { "P_NRETIQUETA": parseInt(nrEtiqueta) }
		});
    };
    
    $scope.bindLabel = function(widgetBindLabel, labelSelected) {
        if (widgetBindLabel.name == 'bindLabel') {
            let variables = {
                DSETIQUETA: labelSelected.DSETIQUETA
            };
            MessageService.confirmMessageByCode('confirmUnlinkLabel', variables, Constants.confirmationMessage).then(() => {
                const widgetAutoForne = templateManager.container.getWidget('autoForne');
    			const checkedRows = widgetAutoForne.dataSource.getCheckedRows();
    			const row = self.buildRowsToUpdate(checkedRows, labelSelected.NRETIQUETA);
    			
    			let promise = self.pushPromiseBindLabel(row);
    			
    			ZHPromise.all(promise).then(function(callbacks) {
    				ScreenService.closePopup(widgetBindLabel);
    				widgetAutoForne.reload();
    			});
            });
        }    
    };
    
    this.buildRowsToUpdate = function(checkedRows, nrLabel) {
		let arrayNrAutoForn = [];
			
		for (let checkedRow of checkedRows) {
			arrayNrAutoForn.push(checkedRow.NRAUTOFORN);
		}
		
		return { 
		    'P_CDOPERADOR': getLocalVar('CDOPERADOR'),
			'P_NRAUTOFORN': arrayNrAutoForn.join('_'),
			'P_NRETIQUETA': nrLabel
		};
	};
	
	this.pushPromiseBindLabel = function(row) {
        return restEngine.post('product#/bindLabels', {
			"requestType": "Row",
			"row": row
		});
    };
    
    this.removeLabelFromList = function(nrEtiquetaToRemove) {
        const widgetLabels = templateManager.container.getWidget('formLabels');
        const arrayLabels = widgetLabels.labels;
        
        for (let label in arrayLabels) {
            if (arrayLabels[label].NRETIQUETA == nrEtiquetaToRemove) {
                arrayLabels.splice(label, 1);
                return true;
            }
        }
        
        return false;
    };
    
    $scope.checkWidget = function(widget) {
        if (widget.name == 'bindLabel') {
            return true;
        }
        
        return false;
    };
}

ZeedhiController.controller('LabelController', LabelController);